# Prepare piece to move

tag @s add move
tag @s add animation

data modify storage chess:data tag.Pos set from entity @s Pos
execute store result score @s chess.start_x run data get storage chess:data tag.Pos[0] 100
execute store result score @s chess.start_z run data get storage chess:data tag.Pos[2] 100

data modify storage chess:data tag.Pos set from entity @e[type=block_display,tag=chess_cursor,tag=target,limit=1] Pos
execute store result score @s chess.end_x run data get storage chess:data tag.Pos[0] 100
execute store result score @s chess.end_z run data get storage chess:data tag.Pos[2] 100

scoreboard players set @s chess.start_y 6400
scoreboard players set @s chess.end_y 6500







# Add en passant tag

tag @s[tag=pawn,tag=!moved,scores={chess.end_z=300..500}] add en_passant







# Special moves

execute if block ~ 63 ~ #chess:special if entity @s[tag=king] run function chess:cursor/move/castle/main
execute if block ~ 63 ~ #chess:special if entity @s[tag=pawn,scores={chess.end_z=050}] run function chess:cursor/move/promotion
execute if block ~ 63 ~ #chess:special if entity @s[tag=pawn,scores={chess.end_z=750}] run function chess:cursor/move/promotion
execute if block ~ 63 ~ #chess:special if entity @s[tag=pawn,scores={chess.end_z=200..600}] run scoreboard players set #en_passant chess.value 1

tag @s remove selected







# Reset board

function chess:generic/reset_board







# Modify player turns

execute if score #pawn_promotion chess.value matches 0 run scoreboard players add #turn chess.value 1
execute if score #turn chess.value matches 3.. run scoreboard players set #turn chess.value 1

scoreboard players set #cursor_player chess.id 0







# Set timer

scoreboard players set #timer chess.value 50
execute if score #pawn_promotion chess.value matches 1 run scoreboard players set #timer chess.value 160